org.apache.poi.poifs.crypt.agile

## Class AgileDecryptor

- java.lang.Object
- - org.apache.poi.poifs.crypt.Decryptor
  - - org.apache.poi.poifs.crypt.agile.AgileDecryptor

- All Implemented Interfaces:
    GenericRecord

      public class AgileDecryptor
      extends Decryptor

  Decryptor implementation for Agile Encryption

- - ### Field Summary

    - ### Fields inherited from class org.apache.poi.poifs.crypt.Decryptor

      `DEFAULT_PASSWORD, DEFAULT_POIFS_ENTRY, encryptionInfo`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AgileDecryptor()`
    `protected` | `AgileDecryptor(AgileDecryptor other)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AgileDecryptor` | `copy()`
    `java.io.InputStream` | `getDataStream(DirectoryNode dir)` Return a stream with decrypted data.
    `long` | `getLength()` Returns the length of the encrypted data that can be safely read with `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`.
    `protected static int` | `getNextBlockSize(int inputLen, int blockSize)`
    `protected static javax.crypto.Cipher` | `initCipherForBlock(javax.crypto.Cipher existing, int block, boolean lastChunk, EncryptionInfo encryptionInfo, javax.crypto.SecretKey skey, int encryptionMode)`
    `boolean` | `verifyPassword(java.security.KeyPair keyPair, java.security.cert.X509Certificate x509)` instead of a password, it's also possible to decrypt via certificate.
    `boolean` | `verifyPassword(java.lang.String password)` set decryption password

    - ### Methods inherited from class org.apache.poi.poifs.crypt.Decryptor

      `getBlockSizeInBytes, getDataStream, getDataStream, getEncryptionInfo, getGenericProperties, getInstance, getIntegrityHmacKey, getIntegrityHmacValue, getKeySizeInBytes, getSecretKey, getVerifier, initCipherForBlock, setChunkSize, setEncryptionInfo, setIntegrityHmacKey, setIntegrityHmacValue, setSecretKey, setVerifier`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.common.usermodel.GenericRecord

      `getGenericChildren, getGenericRecordType`

- - ### Constructor Detail

    - #### AgileDecryptor

          protected AgileDecryptor()

    - #### AgileDecryptor

          protected AgileDecryptor(AgileDecryptor other)

  - ### Method Detail

    - #### verifyPassword

          public boolean verifyPassword(java.lang.String password)
                                 throws java.security.GeneralSecurityException

      set decryption password
      Specified by:
        `verifyPassword` in class `Decryptor`
      Throws:
        `java.security.GeneralSecurityException`

    - #### verifyPassword

          public boolean verifyPassword(java.security.KeyPair keyPair,
                                        java.security.cert.X509Certificate x509)
                                 throws java.security.GeneralSecurityException

      instead of a password, it's also possible to decrypt via certificate. Warning: this code is experimental and hasn't been validated
      Parameters:
        `keyPair` -
        `x509` -
      Returns:
        true, when the data can be successfully decrypted with the given private key
      Throws:
        `java.security.GeneralSecurityException`
      See Also:
        Agile encryption with certificates

    - #### getNextBlockSize

          protected static int getNextBlockSize(int inputLen,
                                                int blockSize)

    - #### getDataStream

          public java.io.InputStream getDataStream(DirectoryNode dir)
                                            throws java.io.IOException,
                                                   java.security.GeneralSecurityException

      Description copied from class: `Decryptor`
      Return a stream with decrypted data.

      Use `Decryptor.getLength()` to get the size of that data that can be safely read from the stream. Just reading to the end of the input stream is not sufficient because there are normally padding bytes that must be discarded

      Specified by:
        `getDataStream` in class `Decryptor`
      Parameters:
        `dir` - the node to read from
      Returns:
        decrypted stream
      Throws:
        `java.io.IOException`
        `java.security.GeneralSecurityException`

    - #### getLength

          public long getLength()

      Description copied from class: `Decryptor`
      Returns the length of the encrypted data that can be safely read with `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`. Just reading to the end of the input stream is not sufficient because there are normally padding bytes that must be discarded

      The length variable is initialized in `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`, an attempt to call getLength() prior to getDataStream() will result in IllegalStateException.

      Specified by:
        `getLength` in class `Decryptor`
      Returns:
        length of the encrypted data

    - #### initCipherForBlock

          protected static javax.crypto.Cipher initCipherForBlock(javax.crypto.Cipher existing,
                                                                  int block,
                                                                  boolean lastChunk,
                                                                  EncryptionInfo encryptionInfo,
                                                                  javax.crypto.SecretKey skey,
                                                                  int encryptionMode)
                                                           throws java.security.GeneralSecurityException

      Throws:
        `java.security.GeneralSecurityException`

    - #### copy

          public AgileDecryptor copy()

      Specified by:
        `copy` in class `Decryptor`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.